/*
** $Id: fontdemo.c,v 1.19 2007-10-31 08:51:19 zhounuohua Exp $
**
** The demo of font.
**
** Copyright (C) 2001 ~ 2002 Wei Yongming.
** Copyright (C) 2003 ~ 2007 Feynman Software.
**
** Create date: 2002/01/17
*/

/*
**  This source is free software; you can redistribute it and/or
**  modify it under the terms of the GNU General Public
**  License as published by the Free Software Foundation; either
**  version 2 of the License, or (at your option) any later version.
**
**  This software is distributed in the hope that it will be useful,
**  but WITHOUT ANY WARRANTY; without even the implied warranty of
**  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
**  General Public License for more details.
**
**  You should have received a copy of the GNU General Public
**  License along with this library; if not, write to the Free
**  Software Foundation, Inc., 59 Temple Place - Suite 330, Boston,
**  MA 02111-1307, USA
*/

/*
** TODO:
*/

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <time.h>

#include <minigui/common.h>
#include <minigui/minigui.h>
#include <minigui/gdi.h>
#include <minigui/window.h>

#define IDM_EXIT            160

#define IDM_TEXTOUT1        200
#define IDM_TEXTOUT2        210
#define IDM_TEXTOUT3        215
#define IDM_TEXTOUT4        216
#define IDM_TABBEDTEXTOUT   220
#define IDM_TABBEDTEXTOUTEX 230
#define IDM_DRAWTEXT        240
#define IDM_ROTATION        250

#define IDM_ABOUT           310

static HMENU createpmenuabout (void)
{
    HMENU hmnu;
    MENUITEMINFO mii;
    memset (&mii, 0, sizeof(MENUITEMINFO));
    mii.type        = MFT_STRING;
    mii.id          = 0;
    mii.typedata    = (DWORD)"About";
    hmnu = CreatePopupMenu (&mii);
    
    memset (&mii, 0, sizeof(MENUITEMINFO));
    mii.type        = MFT_STRING ;
    mii.state       = 0;
    mii.id          = IDM_ABOUT;
    mii.typedata    = (DWORD)"About MiniGUI...";
    InsertMenuItem(hmnu, 3, TRUE, &mii);

    return hmnu;
}

static HMENU createpmenufile (void)
{
    HMENU hmnu;
    MENUITEMINFO mii;
    memset (&mii, 0, sizeof(MENUITEMINFO));
    mii.type        = MFT_STRING;
    mii.id          = 0;
    mii.typedata    = (DWORD)"File";
    hmnu = CreatePopupMenu (&mii);
    
    mii.type        = MFT_STRING;
    mii.state       = 0;
    mii.id          = IDM_EXIT;
    mii.typedata    = (DWORD)"Exit";
    InsertMenuItem(hmnu, 0, TRUE, &mii);

    return hmnu;
}

static HMENU createpmenudialogs (void)
{
    HMENU hmnu;
    MENUITEMINFO mii;
    memset (&mii, 0, sizeof(MENUITEMINFO));
    mii.type        = MFT_STRING;
    mii.id          = 0;
    mii.typedata    = (DWORD)"Text";
    hmnu = CreatePopupMenu (&mii);
    
    mii.type        = MFT_STRING ;
    mii.state       = 0;
    mii.id          = IDM_TEXTOUT1;
    mii.typedata    = (DWORD)"TextOut1...";
    InsertMenuItem(hmnu, 0, TRUE, &mii);
    
    mii.type        = MFT_STRING ;
    mii.state       = 0;
    mii.id          = IDM_TEXTOUT2;
    mii.typedata    = (DWORD)"TextOut2...";
    InsertMenuItem(hmnu, 1, TRUE, &mii);
     
    mii.type        = MFT_STRING ;
    mii.state       = 0;
    mii.id          = IDM_TEXTOUT3;
    mii.typedata    = (DWORD)"TextOut3 (TrueType)...";
    InsertMenuItem(hmnu, 2, TRUE, &mii);

    mii.type        = MFT_STRING ;
    mii.state       = 0;
    mii.id          = IDM_TEXTOUT4;
    mii.typedata    = (DWORD)"TextOut4 (Type1)...";
    InsertMenuItem(hmnu, 2, TRUE, &mii);
     
    mii.type        = MFT_STRING ;
    mii.state       = 0;
    mii.id          = IDM_TABBEDTEXTOUT;
    mii.typedata    = (DWORD)"TabbedTextOut...";
    InsertMenuItem(hmnu, 3, TRUE, &mii);  
    
    mii.type        = MFT_STRING ;
    mii.state       = 0;
    mii.id          = IDM_TABBEDTEXTOUTEX;
    mii.typedata    = (DWORD)"TabbedTextOutEx...";
    InsertMenuItem(hmnu, 4, TRUE, &mii);  

    mii.type        = MFT_STRING ;
    mii.state       = 0;
    mii.id          = IDM_DRAWTEXT;
    mii.typedata    = (DWORD)"DrawText...";
    InsertMenuItem(hmnu, 5, TRUE, &mii);  

    mii.type        = MFT_STRING ;
    mii.state       = 0;
    mii.id          = IDM_ROTATION;
    mii.typedata    = (DWORD)"Rotation...";
    InsertMenuItem(hmnu, 6, TRUE, &mii);  

    return hmnu;
}

static HMENU createmenu (void)
{
    HMENU hmnu;
    MENUITEMINFO mii;

    hmnu = CreateMenu();

    memset (&mii, 0, sizeof(MENUITEMINFO));
    mii.type        = MFT_STRING;
    mii.id          = 100;
    mii.typedata    = (DWORD)"File";
    mii.hsubmenu    = createpmenufile ();

    InsertMenuItem(hmnu, 0, TRUE, &mii);

    mii.type        = MFT_STRING;
    mii.id          = 110;
    mii.typedata    = (DWORD)"Fonts";
    mii.hsubmenu    = createpmenudialogs ();
    InsertMenuItem(hmnu, 1, TRUE, &mii);
    
    mii.type        = MFT_STRING;
    mii.id          = 120;
    mii.typedata    = (DWORD)"About";
    mii.hsubmenu    = createpmenuabout ();
    InsertMenuItem(hmnu, 2, TRUE, &mii);
                   
    return hmnu;
}

#define MODE_TEXTOUT1           11
#define MODE_TEXTOUT2           12
#define MODE_TEXTOUT3           13
#define MODE_TEXTOUT4           14
#define MODE_TABBEDTEXTOUT      20
#define MODE_TABBEDTEXTOUTEX    30
#define MODE_DRAWTEXT           40
#define MODE_ROTATION           50

static PLOGFONT logfontttf1, logfontttf2, logfontttf3, logfontttf4, logfontttf5, logfontttf6,
                logfontttf7, logfontttf8;
static PLOGFONT logfonttype1, logfonttype2, logfonttype3, logfonttype4, logfonttype5, logfonttype6,
                logfonttype7, logfonttype8;
static PLOGFONT logfonthelvb1112, logfonthelv1314, logfonthelv1112, logfontsymb9, logfontsymb11, 
                logfontsymb15, logfontsymb19, logfontsymb26, logfonttimes;
static PLOGFONT lfArial6, lfArial20, lfArial20c, lfKai16, lfSong20, lfTimes12;
static PLOGFONT lfT1a,lfT1b,lfT1c,lfT1d,lfT10,lfT11,lfT12,lfT13,lfT14;


void OnModeTextOut1 (HDC hdc)
{
    SetBkColor (hdc, COLOR_blue);
    SetBkMode (hdc, BM_TRANSPARENT);

    SelectFont (hdc, logfontttf1);
    TextOut (hdc, 0, 0,  "Olympic 2008. [TextOut] Ƶ TrueType-SansSerif-GB2312");

    SelectFont (hdc, logfontttf2);
    TextOut (hdc, 0, 30,  "Olympic 2008. [TextOut] Ƶ TrueType-Courier-GB2312");

    SelectFont (hdc, logfontttf3);
    TextOut (hdc, 0, 60,  "Olympic 2008. [TextOut] Ƶ TrueType-song-GB2312 12x12");

    SelectFont (hdc, logfontttf6);
    TextOut (hdc, 0, 90, "  oOQ TextOut ø奻, ϥΦr^ TrueType-times-BIG5 12x12.");

    SelectFont (hdc, logfontttf4);
    TextOut (hdc, 0, 120,  "Olympic 2008. [TextOut] Ƶ TrueType-fixed-GB2312 16x16");

    SelectFont (hdc, logfontttf7);
    TextOut (hdc, 0, 150, "  oOQ TextOut ø奻, ϥΦr^ TrueType-fmkai-BIG5 16x16.");

    SelectFont (hdc, logfontttf5);
    TextOut (hdc, 0, 180,  "Olympic 2008. [TextOut] Ƶ TrueType-Helvetica-GB2312 24x24");

    SelectFont (hdc, logfontttf8);
    SetBkMode (hdc, BM_TRANSPARENT);
    SetTextColor (hdc, COLOR_red);
    TextOut (hdc, 0, 210,  "Olympic 2008. [TextOut] ø奻, TrueType-ming-BIG5 24x24");
    TextOut (hdc, 0, 240, "  oOQ TextOut ø奻, ϥΦr^ BIG5 Ming 24x24.");
}

#if 1
void OnModeTextOut2 (HDC hdc)
{
    SetBkColor (hdc, COLOR_blue);
    SetBkMode (hdc, BM_TRANSPARENT);

    SelectFont (hdc, logfonttype1);
    TextOut (hdc, 0, 0,  "Olympic 2008. [TextOut] Ƶ type1-SansSerif-GB2312");

    SelectFont (hdc, logfonttype2);
    TextOut (hdc, 0, 30,  "Olympic 2008. [TextOut] Ƶ type1-Courier-GB2312");

    SelectFont (hdc, logfonttype3);
    TextOut (hdc, 0, 60,  "Olympic 2008. [TextOut] Ƶ type1-song-GB2312 12x12");

    SelectFont (hdc, logfonttype6);
    TextOut (hdc, 0, 90, "  oOQ TextOut ø奻, ϥΦr^ type1-times-BIG5 12x12.");

    SelectFont (hdc, logfonttype4);
    TextOut (hdc, 0, 120,  "Olympic 2008. [TextOut] Ƶ type1-fixed-GB2312 16x16");

    SelectFont (hdc, logfonttype7);
    TextOut (hdc, 0, 150, "  oOQ TextOut ø奻, ϥΦr^ type1-fmkai-BIG5 16x16.");

    SelectFont (hdc, logfonttype5);
    TextOut (hdc, 0, 180,  "Olympic 2008. [TextOut] Ƶ type1-Helvetica-GB2312 24x24");

    SelectFont (hdc, logfonttype8);
    SetBkMode (hdc, BM_TRANSPARENT);
    SetTextColor (hdc, COLOR_red);
    TextOut (hdc, 0, 210,  "Olympic 2008. [TextOut] ø奻, type1-ming-BIG5 24x24");
    TextOut (hdc, 0, 240, "  oOQ TextOut ø奻, ϥΦr^ BIG5 Ming 24x24.");
}
#else
void OnModeTextOut2 (HDC hdc)
{
    SetBkColor (hdc, COLOR_lightwhite);

    SelectFont (hdc, logfonthelvb1112);
    TextOut (hdc, 0, 0,  "ABCDEFGHIJKLMNOPQRSTUVWXYZ0123456789");
    TextOut (hdc, 0, 15, "abcdefghijklmnopqrstuvwxyz!@#$%^&*()");
    TextOut (hdc, 0, 30, "~`[];',./\\{}|:\"<>?");
    TextOut (hdc, 0, 45, " TextOut Ƶı, ʹ Font: Helvetica Bold 11*12.");

    SelectFont (hdc, logfonthelv1314);
    TextOut (hdc, 0, 60,  "ABCDEFGHIJKLMNOPQRSTUVWXYZ0123456789");
    TextOut (hdc, 0, 80, "abcdefghijklmnopqrstuvwxyz!@#$%^&*()");
    TextOut (hdc, 0, 100, "~`[];',./\\{}|:\"<>?");
    TextOut (hdc, 0, 120, " TextOut Ƶı, ʹ Font: Helvetica 13*14.");

    SelectFont (hdc, logfonthelv1112);
    TextOut (hdc, 0, 140, "ABCDEFGHIJKLMNOPQRSTUVWXYZ0123456789");
    TextOut (hdc, 0, 155, "abcdefghijklmnopqrstuvwxyz!@#$%^&*()");
    TextOut (hdc, 0, 170, "~`[];',./\\{}|:\"<>?");
    TextOut (hdc, 0, 185, "ghjk  TextOut Ƶı, ʹ Helvetica 11*12.");

    SelectFont (hdc, logfontsymb9);
    TextOut (hdc, 0, 200, "ABCDEFGHIJKLMNOPQRSTUVWXYZ0123456789");
    TextOut (hdc, 0, 210, "abcdefghijklmnopqrstuvwxyz!@#$%^&*()");
    TextOut (hdc, 0, 220, "~`[];',./\\{}|:\"<>?");
    TextOut (hdc, 0, 230, "ghjk  TextOut Ƶı, ʹ Symbol 9*10.");

    SelectFont (hdc, logfontsymb11);
    TextOut (hdc, 0, 240, "ABCDEFGHIJKLMNOPQRSTUVWXYZ0123456789");
    TextOut (hdc, 0, 255, "abcdefghijklmnopqrstuvwxyz!@#$%^&*()");
    TextOut (hdc, 0, 270, "~`[];',./\\{}|:\"<>?");
    TextOut (hdc, 0, 285, "ghjk  TextOut Ƶı, ʹ Symbol 11*10.");

    SelectFont (hdc, logfontsymb15);
    TextOut (hdc, 0, 300, "ABCDEFGHIJKLMNOPQRSTUVWXYZ0123456789");
    TextOut (hdc, 0, 320, "abcdefghijklmnopqrstuvwxyz!@#$%^&*()");
    TextOut (hdc, 0, 340, "~`[];',./\\{}|:\"<>?");
    TextOut (hdc, 0, 360, "ghjk  TextOut Ƶı, ʹ Symbol 15*15.");

    SelectFont (hdc, logfonttimes);
    TextOut (hdc, 0, 380, "ABCDEFGHIJKLMNOPQRSTUVWXYZ0123456789");
    TextOut (hdc, 0, 400, "abcdefghijklmnopqrstuvwxyz!@#$%^&*()");
    TextOut (hdc, 0, 420, "~`[];',./\\{}|:\"<>?");
    TextOut (hdc, 0, 440, "ghjk  TextOut Ƶı, ʹ Times.");

    SelectFont (hdc, logfontsymb19);
    TextOut (hdc, 0, 460, "ABCDEFGHIJKLMNOPQRSTUVWXYZ0123456789");
    TextOut (hdc, 0, 480, "abcdefghijklmnopqrstuvwxyz!@#$%^&*()");
    TextOut (hdc, 0, 500, "~`[];',./\\{}|:\"<>?");
    TextOut (hdc, 0, 520, "ghjk  TextOut Ƶı, ʹ Symbol 19*20.");

    SelectFont (hdc, logfontsymb26);
    TextOut (hdc, 0, 210, "ABCDEFGHIJKLMNOPQRSTUVWXYZ0123456789");
    TextOut (hdc, 0, 240, "abcdefghijklmnopqrstuvwxyz!@#$%^&*()");
    TextOut (hdc, 0, 270, "~`[];',./\\{}|:\"<>?");
//    TextOut (hdc, 0, 300, "ghjk  TextOut Ƶı, ʹ Symbol 26*25.");

}
#endif

void OnModeTextOut3 (HDC hdc)
{
    SetBkMode (hdc, BM_TRANSPARENT);
    SetBkColor (hdc, COLOR_lightwhite);
    SetTextColor (hdc, COLOR_black);

    SelectFont (hdc, lfArial6);
    TextOut (hdc, 0, 0,  "Aa2!@#$%^& TextOut Ƶı Font: TrueType Arial size 14");

    SelectFont (hdc, lfArial20);
    TextOut (hdc, 0, 30,  "Aa2!@#$%^& TextOut Ƶı Font: type1 Arial size 30");

    SelectFont (hdc, lfArial20c);
    SetBkMode (hdc, BM_TRANSPARENT);
    SetTextColor (hdc, COLOR_red);
    TextOut (hdc, 0, 60,  "Aa2!@#$%^& TextOut Ƶı Font: type1 Arial size 30");
#if 0
    SetBkMode (hdc, BM_TRANSPARENT);
    SetTextColor (hdc, COLOR_red);
    SelectFont (hdc, lfArial20);
    TextOut (hdc, 0, 60,  "JjklgLgPjOgRWn: not condensed");

    SelectFont (hdc, lfArial20c);
    TextOut (hdc, 0, 90,  "JjklgLgPjOgRWn: condensed");

    SelectFont (hdc, lfTimes12);
    TextOut (hdc, 20, 400,  "ABCDEFGHIJkasdkfj");
#endif

}

void OnModeTextOut4 (HDC hdc)
{
    SetBkMode (hdc, BM_TRANSPARENT);
    SetBkColor (hdc, COLOR_lightwhite);
    SetTextColor (hdc, COLOR_black);

    SelectFont (hdc, lfT1a);
    TextOut (hdc, 0, 20,  "This is Type1 Charter:");
    TextOut (hdc, 0, 50,  "ABCDEFGHIJKLMNOPQRSTUVWXYZ0123456789");

    SelectFont (hdc, lfT1b);
    TextOut (hdc, 0, 80,  "This is Type1 Charter Italic:");
    TextOut (hdc, 0, 110,  "ABCDEFGHIJKLMNOPQRSTUVWXYZ0123456789");

    SelectFont (hdc, lfT1c);
    TextOut (hdc, 0, 140,  "This is Type1 Charter Bold:");
    TextOut (hdc, 0, 160,  "ABCDEFGHIJKLMNOPQRSTUVWXYZ0123456789");

    SelectFont (hdc, lfT1d);
    TextOut (hdc, 0, 180,  "This is Type1 Charter Bold Italic:");
    TextOut (hdc, 0, 210,  "ABCDEFGHIJKLMNOPQRSTUVWXYZ0123456789");

    SelectFont (hdc, lfT10);
    TextOut (hdc, 0, 240,  "This is Type1 Courier:");
    TextOut (hdc, 0, 270,  "ABCDEFGHIJKLMNOPQRSTUVWXYZ0123456789");

    SelectFont (hdc, lfT11);
    TextOut (hdc, 0, 300,  "This is Type1 Courier Italic:");
    TextOut (hdc, 0, 330,  "ABCDEFGHIJKLMNOPQRSTUVWXYZ0123456789");
    
    SelectFont (hdc, lfT12);
    TextOut (hdc, 0, 360,  "This is Type1 Courier Bold:");
    TextOut (hdc, 0, 390,  "ABCDEFGHIJKLMNOPQRSTUVWXYZ0123456789");

    SelectFont (hdc, lfT13);
    TextOut (hdc, 0, 450,  "This is Type1 Courier Bold Italic:");
    TextOut (hdc, 0, 500,  "ABCDEFGHIJKLMNOPQRSTUVWXYZ0123456789");

    SelectFont (hdc, lfT14);
    TextOut (hdc, 0, 600,  "eufm10: ABCDEFGH");
}
void OnModeTabbedTextOut (HDC hdc)
{
    SetBkColor (hdc, COLOR_lightwhite);

    SelectFont (hdc, logfontttf4);
    TabbedTextOut (hdc, 0, 0, "ABCD1234\tEFGHIJK\t\tLMNOPQRST\tUVWXYZ\t0123456789\n"
                              "The quick fox jumps over the lazy dog.\n"
                              " TextOut Ƶı, ʹ GB2312 Song 16x16");

    SetTabStop (hdc, 4);
    SelectFont (hdc, logfontttf7);
    TabbedTextOut (hdc, 0, 100, "ABCD123\tEFGHIJK\t\tLMNOPQRST\tUVWXYZ\t0123456789\n"
                              "The quick fox jumps over the lazy dog.\n"
                              "oOQ TextOut ø奻, ϥΦr^ BIG5 Ming 16x16");
}

void OnModeTabbedTextOutEx (HDC hdc)
{
    int i;
    int pos = 0;
    int tab_stops [] = {40, 40, 70, 40, 70, 90};

    SetBkColor (hdc, COLOR_lightwhite);

    MoveTo (hdc, 0, 5);
    LineTo (hdc, 600, 5);

    for (i = 0; i < 6; i++) {
        pos += tab_stops [i];
        MoveTo (hdc, pos, 2);
        LineTo (hdc, pos, 8);
    }

    SelectFont (hdc, logfontttf4);
    TabbedTextOutEx (hdc, 0, 10, "ABCD\tEFGHIJK\t\tLMNOPQRST\tUVWXYZ\t\t0123456789\t", -1,
                            6, tab_stops, 0);
    TabbedTextOutEx (hdc, 0, 50, "ABCD\tEFGHIJK\t\tLMNOPQRST\t\tUVWXYZ\t\t0123456789", -1,
                            6, tab_stops, 10);
    TabbedTextOutEx (hdc, 0, 90, "ABCD\tEFGHIJK\t\tLMNOPQRST\n\t\tUVWXY\t\t0123456789", -1,
                            6, tab_stops, 0);
    TabbedTextOutEx (hdc, 0, 150, "The\tquick\tfox\tjumps\tover\tthe\tlazy\tdog.", -1,
                            6, tab_stops, 0);

    tab_stops [0] = 200;
    TabbedTextOutEx (hdc, 0, 200, "TabbedTextOutEx:\tadfsj aksjdfk akjdfs;j;kjkju kaj dfkj iqwerkjj\n"
                                  "\tasdf asfd asdf asdfasdff asdfaf sdf.", -1, 6, tab_stops, 0);
    TabbedTextOutEx (hdc, 0, 340, "TabbedTextOutEx:\tI am kajsdf jk;asdf lkjfsd \n"
                                  "\taskdf asdfiouqwer kjuujker  asdfjqweru ;asdfj\n"
                                  "\tasdf asfd asdf asdfasdff asdfaf sdf.", -1, 6, tab_stops, 0);
    TabbedTextOutEx (hdc, 0, 400, "TabbedTextOutEx:\tI am kajsdf jk;asdf lkjfsd \n"
                                  "\taskdf asdf iouqwer kjuujker  asdfjqweru ;asdfj\n"
                                  "\tasdf asfd asdf asdfasdff asdfaf sdf.", -1, 6, tab_stops, 0);

    SetTextCharacterExtra (hdc, 3);
    SetTextAboveLineExtra (hdc, 2);
    SetTextBellowLineExtra (hdc, 4);
    TabbedTextOutEx (hdc, 0, 500, "TabbedTextOutEx:\tI am kajsdf jk;asdf lkjfsd \n"
                                  "\taskdf asdf iouqwer kjuujker  asdfjqweru ;asdfj\n"
                                  "\tasdf asfd asdf asdfasdff asdfaf sdf.", -1, 6, tab_stops, 0);
    SetTextCharacterExtra (hdc, 0);
    SetTextAboveLineExtra (hdc, 0);
    SetTextBellowLineExtra (hdc, 0);
}

void OnModeDrawText (HDC hdc)
{
#if 1
    RECT rc1, rc2, rc3, rc4;
    const char* szBuff1 = "This is a good day. \n"
            " DrawText Ƶġı, ʹ GB2312 Song 12. "
            "ıֱ, ˮƽ";
    const char* szBuff2 = "This is a good day. \n"
            " DrawText Ƶġı, ʹ GB2312 Song 16. "
            "ıֱ, ˮƽ";
    const char* szBuff3 = "ıֱ, ˮƽ";
    const char* szBuff4 = 
            " DrawTextEx Ƶı, ʹ GB2312 Song 16. "
            "ֵΪ 32. ıֱ, ˮƽ";

    rc1.left = 1; rc1.top  = 1; rc1.right = 401; rc1.bottom = 101;
    rc2.left = 0; rc2.top  = 110; rc2.right = 401; rc2.bottom = 251;
    rc3.left = 0; rc3.top  = 261; rc3.right = 401; rc3.bottom = 351;
    rc4.left = 0; rc4.top  = 361; rc4.right = 401; rc4.bottom = 451;

    SetBkColor (hdc, COLOR_lightwhite);

    Rectangle (hdc, rc1.left, rc1.top, rc1.right, rc1.bottom);
    Rectangle (hdc, rc2.left, rc2.top, rc2.right, rc2.bottom);
    Rectangle (hdc, rc3.left, rc3.top, rc3.right, rc3.bottom);
    Rectangle (hdc, rc4.left, rc4.top, rc4.right, rc4.bottom);

    InflateRect (&rc1, -1, -1);
    InflateRect (&rc2, -1, -1);
    InflateRect (&rc3, -1, -1);
    InflateRect (&rc4, -1, -1);

    SelectFont (hdc, logfontttf3);
    DrawText (hdc, szBuff1, -1, &rc1, DT_NOCLIP | DT_CENTER | DT_WORDBREAK);

    SelectFont (hdc, logfontttf4);
    DrawText (hdc, szBuff2, -1, &rc2, DT_NOCLIP | DT_RIGHT | DT_WORDBREAK);

    SelectFont (hdc, logfontttf5);
    DrawText (hdc, szBuff3, -1, &rc3, DT_NOCLIP | DT_SINGLELINE | DT_CENTER | DT_VCENTER);

    SelectFont (hdc, logfontttf4);
    DrawTextEx (hdc, szBuff4, -1, &rc4, 32, DT_LEFT | DT_WORDBREAK);

#else

    PLOGFONT font = CreateLogFont ("ttf", "arial", "GB2312", 
                      FONT_WEIGHT_SUBPIXEL, FONT_SLANT_ROMAN,
                      FONT_SETWIDTH_NORMAL,
                      FONT_SPACING_CHARCELL, 
                      FONT_UNDERLINE_NONE, FONT_STRUCKOUT_NONE, 
                      36, 0);

    SelectFont (hdc, font);
    TextOut (hdc, 0, 0,  "ABCDEFGHIJKLMNOPQRSTUVWXYZ0123456789");
    TextOut (hdc, 0, 50, "bcdefghijklmnopqrstuvwxyz!@#$%^&*()");
    TextOut (hdc, 0, 100, "~`[];',./\\{}|:\"<>?");
    TextOut (hdc, 0, 150, "TrueType Arial size 14");

#endif
}

void OnModeRotation (HWND hWnd, HDC hdc)
{
    int degrees, i, x, y;
    PLOGFONT logfont;
    RECT client;

    GetClientRect (hWnd, &client);

    SetBkMode (hdc, BM_TRANSPARENT);
    SelectFont (hdc, lfSong20);
    
    srandom (time(NULL));
    for (i = 0; i < 500; i++) {
        x = random() % (RECTW (client));
        y = random() % (RECTH (client));
        SetTextColor(hdc, RGB2Pixel (hdc, random() % 0x100, 
                                      random() % 0x100,
                                      random() % 0x100));
        TextOut (hdc, x, y, "MiniGUI ̫ţˣ");
    }

    SetPenColor(hdc, COLOR_black);
    for (i = 0; i < 400; i+=1) {
        Rectangle (hdc, 400 - i, 340 - i, 400 + i, 340 + i);
    }

    SetBkColor(hdc, COLOR_black);
    for (degrees = 0; degrees < 360; degrees += 10) {
        logfont = CreateLogFont ("ttf", "times", "ISO8859-1", 
                        FONT_WEIGHT_REGULAR, FONT_SLANT_ROMAN, FONT_SETWIDTH_NORMAL,
                        FONT_SPACING_CHARCELL, FONT_UNDERLINE_NONE, FONT_STRUCKOUT_NONE, 
                        36, degrees * 10);
        SelectFont (hdc, logfont);
        i = degrees / 10;
        SetTextColor (hdc, SysPixelIndex [i % 15 + 1]);
        TextOut (hdc, 400, 320, "MiniGUI IS GREAT!");
        DestroyLogFont (logfont);
    }

}
        
int FontTestMainWinProc (HWND hWnd, int message, WPARAM wParam, LPARAM lParam)
{
    static int mode = MODE_TEXTOUT1;

    switch (message) {
        case MSG_CREATE:

            /** tty font*/
            logfontttf1 = CreateLogFont ("ttf", "SansSerif", "GB2312", 
                        FONT_WEIGHT_REGULAR, FONT_SLANT_ITALIC, 
                        FONT_SETWIDTH_NORMAL, FONT_SPACING_CHARCELL, 
                        FONT_UNDERLINE_NONE, FONT_STRUCKOUT_NONE, 
                        16, 0);
            logfontttf2 = CreateLogFont ("ttf", "Courier", "GB2312",
                        FONT_WEIGHT_BOLD, FONT_SLANT_ROMAN, 
                        FONT_FLIP_NIL, FONT_OTHER_AUTOSCALE, 
                        FONT_UNDERLINE_LINE, FONT_STRUCKOUT_NONE, 
                        16, 0);
            logfontttf3 = CreateLogFont ("ttf", "song", "GB2312", 
                        FONT_WEIGHT_LIGHT,
                        FONT_SLANT_ROMAN, FONT_SETWIDTH_NORMAL,
                        FONT_OTHER_TTFNOCACHE, FONT_UNDERLINE_NONE, 
                        FONT_STRUCKOUT_NONE, 
                        12, 0);
            logfontttf4 = CreateLogFont ("ttf", "fixed", "GB2312", 
                        FONT_WEIGHT_BLACK,
                        FONT_SLANT_ROMAN, FONT_FLIP_NIL,
                        FONT_OTHER_TTFKERN, FONT_UNDERLINE_NONE, 
                        FONT_STRUCKOUT_NONE, 
                        16, 0);
            logfontttf5 = CreateLogFont ("ttf", "Helvetica", "GB2312", 
                        FONT_WEIGHT_BOLD, FONT_SLANT_ITALIC, 
                        FONT_SETWIDTH_NORMAL, FONT_OTHER_TTFNOCACHEKERN, 
                        FONT_UNDERLINE_NONE, FONT_STRUCKOUT_NONE, 
                        24, 0);
            logfontttf6 = CreateLogFont ("ttf", "times", "BIG5", 
                        FONT_WEIGHT_LIGHT, FONT_SLANT_ROMAN, 
                        FONT_SETWIDTH_NORMAL, FONT_OTHER_LCDPORTRAIT, 
                        FONT_UNDERLINE_NONE, FONT_STRUCKOUT_NONE, 
                        12, 0);
            logfontttf7 = CreateLogFont ("ttf", "fmkai", "BIG5", 
                        FONT_WEIGHT_BLACK, FONT_SLANT_ROMAN, 
                        FONT_SETWIDTH_NORMAL, FONT_OTHER_LCDPORTRAITKERN, 
                        FONT_UNDERLINE_NONE, FONT_STRUCKOUT_LINE, 
                        16, 0);
            logfontttf8 = CreateLogFont ("ttf", "ming", "BIG5", 
                        FONT_WEIGHT_SUBPIXEL, FONT_SLANT_ROMAN, 
                        FONT_FLIP_NIL, FONT_SPACING_CHARCELL, 
                        FONT_UNDERLINE_LINE, FONT_STRUCKOUT_NONE, 
                        24, 0);
            /** type1 font */

            logfonttype1 = CreateLogFont ("type1", "SansSerif", "GB2312", 
                        FONT_WEIGHT_REGULAR, FONT_SLANT_ITALIC, 
                        FONT_SETWIDTH_NORMAL, FONT_SPACING_CHARCELL, 
                        FONT_UNDERLINE_NONE, FONT_STRUCKOUT_NONE, 
                        16, 0);
            logfonttype2 = CreateLogFont ("type1", "Courier", "GB2312",
                        FONT_WEIGHT_BOLD, FONT_SLANT_ROMAN, 
                        FONT_FLIP_NIL, FONT_OTHER_AUTOSCALE, 
                        FONT_UNDERLINE_LINE, FONT_STRUCKOUT_NONE, 
                        16, 0);
            logfonttype3 = CreateLogFont ("type1", "song", "GB2312", 
                        FONT_WEIGHT_LIGHT,
                        FONT_SLANT_ROMAN, FONT_SETWIDTH_NORMAL,
                        FONT_OTHER_TTFNOCACHE, FONT_UNDERLINE_NONE, 
                        FONT_STRUCKOUT_NONE, 
                        12, 0);
            logfonttype4 = CreateLogFont ("type1", "fixed", "GB2312", 
                        FONT_WEIGHT_BLACK,
                        FONT_SLANT_ROMAN, FONT_FLIP_NIL,
                        FONT_OTHER_TTFKERN, FONT_UNDERLINE_NONE, 
                        FONT_STRUCKOUT_NONE, 
                        16, 0);
            logfonttype5 = CreateLogFont ("type1", "Helvetica", "GB2312", 
                        FONT_WEIGHT_BOLD, FONT_SLANT_ITALIC, 
                        FONT_SETWIDTH_NORMAL, FONT_OTHER_TTFNOCACHEKERN, 
                        FONT_UNDERLINE_NONE, FONT_STRUCKOUT_NONE, 
                        24, 0);
            logfonttype6 = CreateLogFont ("type1", "times", "BIG5", 
                        FONT_WEIGHT_LIGHT, FONT_SLANT_ROMAN, 
                        FONT_SETWIDTH_NORMAL, FONT_OTHER_LCDPORTRAIT, 
                        FONT_UNDERLINE_NONE, FONT_STRUCKOUT_NONE, 
                        12, 0);
            logfonttype7 = CreateLogFont ("type1", "fmkai", "BIG5", 
                        FONT_WEIGHT_BLACK, FONT_SLANT_ROMAN, 
                        FONT_SETWIDTH_NORMAL, FONT_OTHER_LCDPORTRAITKERN, 
                        FONT_UNDERLINE_NONE, FONT_STRUCKOUT_LINE, 
                        16, 0);
            logfonttype8 = CreateLogFont ("type1", "ming", "BIG5", 
                        FONT_WEIGHT_BOOK, FONT_SLANT_ROMAN, 
                        FONT_FLIP_NIL, FONT_SPACING_CHARCELL, 
                        FONT_UNDERLINE_LINE, FONT_STRUCKOUT_NONE, 
                        24, 0);

            logfonthelvb1112 = CreateLogFont (NULL, "Helvetica", "ISO8859-1", 
                        FONT_WEIGHT_LIGHT, FONT_SLANT_ROMAN, FONT_FLIP_NIL,
                        FONT_SPACING_CHARCELL, FONT_UNDERLINE_NONE, FONT_STRUCKOUT_NONE, 
                        12, 0);
            logfonthelv1314 = CreateLogFont (NULL, "Unifont", "GB2312", 
                        FONT_WEIGHT_MEDIUM, FONT_SLANT_ROMAN, FONT_SETWIDTH_NORMAL,
                        FONT_SPACING_CHARCELL, FONT_UNDERLINE_NONE, FONT_STRUCKOUT_NONE, 
                        16, 0);
            logfonthelv1112 = CreateLogFont (NULL, "Helvetica", "ISO8859-1", 
                        FONT_WEIGHT_SUBPIXEL, FONT_SLANT_ROMAN, FONT_SETWIDTH_NORMAL,
                        FONT_SPACING_CHARCELL, FONT_UNDERLINE_NONE, FONT_STRUCKOUT_NONE, 
                        12, 0);
            logfontsymb9 = CreateLogFont (NULL, "Symbol", "ISO8859-1", 
                        FONT_WEIGHT_BLACK, FONT_SLANT_ROMAN, FONT_SETWIDTH_NORMAL,
                        FONT_SPACING_CHARCELL, FONT_UNDERLINE_NONE, FONT_STRUCKOUT_NONE, 
                        10, 0);
            logfontsymb11 = CreateLogFont (NULL, "Symbol", "ISO8859-1", 
                        FONT_WEIGHT_DEMIBOLD, FONT_SLANT_ROMAN, FONT_SETWIDTH_NORMAL,
                        FONT_SPACING_CHARCELL, FONT_UNDERLINE_NONE, FONT_STRUCKOUT_LINE, 
                        10, 0);
            logfontsymb15 = CreateLogFont (NULL, "Symbol", "ISO8859-1", 
                        FONT_WEIGHT_LIGHT, FONT_SLANT_ROMAN, FONT_SETWIDTH_NORMAL,
                        FONT_SPACING_CHARCELL, FONT_UNDERLINE_NONE, FONT_STRUCKOUT_NONE, 
                        15, 0);
            logfontsymb19 = CreateLogFont (NULL, "Symbol", "ISO8859-1", 
                        FONT_WEIGHT_MEDIUM, FONT_SLANT_ROMAN, FONT_SETWIDTH_NORMAL,
                        FONT_SPACING_CHARCELL, FONT_UNDERLINE_NONE, FONT_STRUCKOUT_NONE, 
                        20, 0);
            logfontsymb26 = CreateLogFont (NULL, "Symbol", "ISO8859-1", 
                        FONT_WEIGHT_SUBPIXEL, FONT_SLANT_ROMAN, FONT_SETWIDTH_NORMAL,
                        FONT_SPACING_CHARCELL, FONT_UNDERLINE_NONE, FONT_STRUCKOUT_NONE, 
                        25, 0);
            logfonttimes = CreateLogFont (NULL, "Times", "ISO8859-1", 
                        FONT_WEIGHT_REGULAR, FONT_SLANT_ROMAN, FONT_FLIP_HORZ,
                        FONT_SPACING_CHARCELL, FONT_UNDERLINE_LINE, FONT_STRUCKOUT_NONE, 
                        19, 0);
            lfArial6 = CreateLogFont ("ttf", "arial", "GBK", 
                        FONT_WEIGHT_SUBPIXEL | FONT_WEIGHT_REGULAR, 
                        FONT_SLANT_ROMAN, FONT_FLIP_NIL,
                        FONT_SPACING_CHARCELL, FONT_UNDERLINE_NONE, FONT_STRUCKOUT_NONE, 
                        14, 0);
            lfArial20 = CreateLogFont ("type1", "arial", "GB2312", 
                        FONT_WEIGHT_BOOK | FONT_WEIGHT_REGULAR, 
                        FONT_SLANT_ITALIC, FONT_SETWIDTH_NORMAL,
                        FONT_SPACING_CHARCELL, FONT_UNDERLINE_NONE, FONT_STRUCKOUT_NONE, 
                        30, 0);
            lfArial20c = CreateLogFont ("type1", "arial", "GB2312", 
                        FONT_WEIGHT_BOOK | FONT_WEIGHT_BOLD, 
                        FONT_SLANT_ROMAN, FONT_FLIP_NIL,
                        FONT_SPACING_CHARCELL, FONT_UNDERLINE_NONE, FONT_STRUCKOUT_NONE, 
                        30, 0);
            lfKai16 = CreateLogFont ("ttf", "fmkai", "GB2312", 
                        FONT_WEIGHT_REGULAR | FONT_WEIGHT_SUBPIXEL, 
                        FONT_SLANT_ROMAN, FONT_SETWIDTH_NORMAL,
                        FONT_SPACING_CHARCELL, FONT_UNDERLINE_NONE, FONT_STRUCKOUT_NONE, 
                        36, 0);
            lfSong20 = CreateLogFont ("ttf", "song", "GB2312", 
                        FONT_WEIGHT_REGULAR | FONT_WEIGHT_LIGHT, 
                        FONT_SLANT_ROMAN, FONT_SETWIDTH_NORMAL,
                        FONT_SPACING_CHARCELL, FONT_UNDERLINE_NONE, FONT_STRUCKOUT_NONE, 
                        36, 0);
            lfTimes12 = CreateLogFont ("ttf", "times", "ISO8859-1", 
                        FONT_WEIGHT_REGULAR, FONT_SLANT_ITALIC, FONT_SETWIDTH_NORMAL,
                        FONT_SPACING_CHARCELL, FONT_UNDERLINE_LINE, FONT_STRUCKOUT_NONE, 
                        24, 200);
	    //static PLOGFONT lfT1a,lfT1b,lfT1c,lfT1d,lfT10,lfT11,lfT12,lfT13;
            lfT1a = CreateLogFont ("type1", "Charter", "ISO8859-1", 
                        FONT_WEIGHT_REGULAR, FONT_SLANT_ROMAN, FONT_SETWIDTH_NORMAL,
                        FONT_SPACING_CHARCELL, FONT_UNDERLINE_LINE, FONT_STRUCKOUT_NONE, 
                        16, 0);
            lfT1b = CreateLogFont ("type1", "Charter", "ISO8859-1", 
                        FONT_WEIGHT_BOOK, FONT_SLANT_ITALIC, FONT_SETWIDTH_NORMAL,
                        FONT_SPACING_PROPORTIONAL, FONT_UNDERLINE_LINE, FONT_STRUCKOUT_NONE, 
                        16, 0);
            lfT1c = CreateLogFont ("type1", "Charter", "ISO8859-1", 
                        FONT_WEIGHT_BOOK, FONT_SLANT_ROMAN, FONT_SETWIDTH_NORMAL,
                        FONT_SPACING_CHARCELL, FONT_UNDERLINE_LINE, FONT_STRUCKOUT_NONE, 
                        18, 0);
            lfT1d = CreateLogFont ("type1", "Charter", "ISO8859-1", 
                        FONT_WEIGHT_BOOK, FONT_SLANT_ITALIC, FONT_SETWIDTH_NORMAL,
                        FONT_SPACING_CHARCELL, FONT_UNDERLINE_LINE, FONT_STRUCKOUT_NONE, 
                        18, 0);
            lfT10 = CreateLogFont ("type1", "Courier", "ISO8859-1", 
                        FONT_WEIGHT_REGULAR, FONT_SLANT_ROMAN, FONT_SETWIDTH_NORMAL,
                        FONT_SPACING_MONOSPACING, FONT_UNDERLINE_LINE, FONT_STRUCKOUT_NONE, 
                        18, 0);
            lfT11 = CreateLogFont ("type1", "Courier", "ISO8859-1", 
                        FONT_WEIGHT_REGULAR, FONT_SLANT_ITALIC, FONT_SETWIDTH_NORMAL,
                        FONT_SPACING_CHARCELL, FONT_UNDERLINE_LINE, FONT_STRUCKOUT_NONE, 
                        24, 0);
            lfT12 = CreateLogFont ("type1", "Courier", "ISO8859-1", 
                        FONT_WEIGHT_BOLD, FONT_SLANT_ROMAN, FONT_SETWIDTH_NORMAL,
                        FONT_SPACING_CHARCELL, FONT_UNDERLINE_LINE, FONT_STRUCKOUT_NONE, 
                        24, 0);

            lfT13 = CreateLogFont ("type1", "Courier", "ISO8859-1", 
                        FONT_WEIGHT_BOLD, FONT_SLANT_ITALIC, FONT_SETWIDTH_NORMAL,
                        FONT_SPACING_CHARCELL, FONT_UNDERLINE_LINE, FONT_STRUCKOUT_NONE, 
                        30, 0);

            lfT14 = CreateLogFont ("type1", "eufm10", "ISO8859-1", 
                        FONT_WEIGHT_REGULAR, FONT_SLANT_ROMAN, FONT_SETWIDTH_NORMAL,
                        FONT_SPACING_CHARCELL, FONT_UNDERLINE_LINE, FONT_STRUCKOUT_NONE, 
                        40, 200);
        break;

        case MSG_PAINT:
        {
            HDC hdc;

            hdc = BeginPaint (hWnd);

            switch (mode) {
            case MODE_TEXTOUT1:
                OnModeTextOut1 (hdc);
                break;
            case MODE_TEXTOUT2:
                OnModeTextOut2 (hdc);
                break;
            case MODE_TEXTOUT3:
                OnModeTextOut3 (hdc);
                break;
            case MODE_TEXTOUT4:
                OnModeTextOut4 (hdc);
                break;
            case MODE_TABBEDTEXTOUT:
                OnModeTabbedTextOut (hdc);
                break;
            case MODE_TABBEDTEXTOUTEX:
                OnModeTabbedTextOutEx (hdc);
                break;
            case MODE_DRAWTEXT:
                OnModeDrawText (hdc);
                break;
            case MODE_ROTATION:
                OnModeRotation (hWnd, hdc);
                break;
            }

            EndPaint (hWnd, hdc);
            return 0;
        }
        
        case MSG_COMMAND:
        switch (wParam) 
        {
            case IDM_EXIT:
                SendMessage (hWnd, MSG_CLOSE, 0, 0L);
            break;

            case IDM_TEXTOUT1:
                mode = MODE_TEXTOUT1;
                InvalidateRect (hWnd, NULL, TRUE);
            break;
            
            case IDM_TEXTOUT2:
                mode = MODE_TEXTOUT2;
                InvalidateRect (hWnd, NULL, TRUE);
            break;
            
            case IDM_TEXTOUT3:
                mode = MODE_TEXTOUT3;
                InvalidateRect (hWnd, NULL, TRUE);
            break;

            case IDM_TEXTOUT4:
                mode = MODE_TEXTOUT4;
            InvalidateRect (hWnd,NULL,TRUE);
            break;
            
            case IDM_TABBEDTEXTOUT:
                mode = MODE_TABBEDTEXTOUT;
                InvalidateRect (hWnd, NULL, TRUE);
            break;
            
            case IDM_TABBEDTEXTOUTEX:
                mode = MODE_TABBEDTEXTOUTEX;
                InvalidateRect (hWnd, NULL, TRUE);
            break;
            
            case IDM_DRAWTEXT:
                mode = MODE_DRAWTEXT;
                InvalidateRect (hWnd, NULL, TRUE);
            break;

            case IDM_ROTATION:
                mode = MODE_ROTATION;
                InvalidateRect (hWnd, NULL, TRUE);
            break;

            case IDM_ABOUT:
            break;
        }
        break;

        case MSG_CLOSE:
            if (MessageBox (hWnd, 
                            "Are you sure to quit?", 
                            "FontTest", 
                            MB_YESNOCANCEL | MB_ICONQUESTION) != IDYES)
                return 0;

            DestroyLogFont (logfontttf1);
            DestroyLogFont (logfontttf2);
            DestroyLogFont (logfontttf3);
            DestroyLogFont (logfontttf4);
            DestroyLogFont (logfontttf5);
            DestroyLogFont (logfontttf6);
            DestroyLogFont (logfontttf7);
            DestroyLogFont (logfontttf8);
            DestroyLogFont (logfonttype1);
            DestroyLogFont (logfonttype2);
            DestroyLogFont (logfonttype3);
            DestroyLogFont (logfonttype4);
            DestroyLogFont (logfonttype5);
            DestroyLogFont (logfonttype6);
            DestroyLogFont (logfonttype7);
            DestroyLogFont (logfonttype8);
            DestroyLogFont (logfonthelvb1112);
            DestroyLogFont (logfonthelv1314);
            DestroyLogFont (logfonthelv1112);
            DestroyLogFont (logfontsymb9);
            DestroyLogFont (logfontsymb11);
            DestroyLogFont (logfontsymb15);
            DestroyLogFont (logfontsymb19);
            DestroyLogFont (logfontsymb26);
            DestroyLogFont (logfonttimes);
            DestroyLogFont (lfArial6);
            DestroyLogFont (lfArial20);
            DestroyLogFont (lfArial20c);
            DestroyLogFont (lfKai16);
            DestroyLogFont (lfSong20);
            DestroyLogFont (lfTimes12);
            DestroyMainWindow (hWnd);
            PostQuitMessage (hWnd);
        return 0;
    }

    return DefaultMainWinProc (hWnd, message, wParam, lParam);
}

static void InitCreateInfo (PMAINWINCREATE pCreateInfo)
{
    pCreateInfo->dwStyle = WS_CAPTION | WS_BORDER | WS_SYSMENU;
    pCreateInfo->dwExStyle = WS_EX_NONE;
    pCreateInfo->spCaption = "The font test main window";
    pCreateInfo->hMenu = createmenu ();
    pCreateInfo->hCursor = GetSystemCursor (IDC_ARROW);
    pCreateInfo->hIcon = GetSmallSystemIcon (IDI_APPLICATION);
    pCreateInfo->MainWindowProc = FontTestMainWinProc;
    pCreateInfo->lx = 0; 
    pCreateInfo->ty = 0;
    pCreateInfo->rx = 1024;
    pCreateInfo->by = 700;
    pCreateInfo->iBkColor = COLOR_lightwhite; 
    pCreateInfo->dwAddData = 0;
    pCreateInfo->hHosting = HWND_DESKTOP;
}

int MiniGUIMain (int args, const char* arg[])
{
    MSG Msg;
    MAINWINCREATE CreateInfo;
    HWND hMainWnd;

#if defined(_LITE_VERSION) && !(_STAND_ALONE)
    int i;
    const char* layer = NULL;

    for (i = 1; i < args; i++) {
        if (strcmp (arg[i], "-layer") == 0) {
            layer = arg[i + 1];
            break;
        }
    }

    GetLayerInfo (layer, NULL, NULL, NULL);

    if (JoinLayer (layer, arg[0], 0, 0) == INV_LAYER_HANDLE) {
        printf ("JoinLayer: invalid layer handle.\n");
        exit (1);
    }

    if (!InitVectorialFonts ()) {
        printf ("InitVectorialFonts: error.\n");
        exit (2);
    }

#endif

    InitCreateInfo (&CreateInfo);

    hMainWnd = CreateMainWindow (&CreateInfo);
    if (hMainWnd == HWND_INVALID)
        exit (3);

    ShowWindow (hMainWnd, SW_SHOWNORMAL);
    while (GetMessage (&Msg, hMainWnd)) {
        TranslateMessage (&Msg);
        DispatchMessage (&Msg);
    }

    MainWindowThreadCleanup (hMainWnd);

#ifdef _LITE_VERSION
    TermVectorialFonts ();
#endif
    return 0;
}

#ifndef _LITE_VERSION
#include <minigui/dti.c>
#endif
